package com.ejie.ab79.dao.actuaciones;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;
import javax.sql.DataSource;

import org.springframework.dao.support.DataAccessUtils;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab79.model.Inspectores;
import com.ejie.ab79.model.REST.servicioWeb.Actuacion;
import com.ejie.ab79.model.REST.servicioWeb.Compareciente;
import com.ejie.ab79.model.actuaciones.Actuaciones;
import com.ejie.ab79.model.actuaciones.DesResAct;
import com.ejie.ab79.model.actuaciones.ResultadosActuacion;
import com.ejie.ab79.model.actuaciones.TiposActuacion;
import com.ejie.ab79.model.expedientes.DatosTerceros;
import com.ejie.ab79.model.expedientes.TiposDocumento;
import com.ejie.ab79.model.inspecciones.Inspecciones;
import com.ejie.x38.dao.RowNumResultSetExtractor;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableManager;
import com.ejie.x38.dto.TableManagerJerarquia;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * ActuacionesDaoImpl  
 * 
 *  
 */

@Repository
@Transactional
public class ActuacionesDaoImpl implements ActuacionesDao {

	public static final String[] ORDER_BY_WHITE_LIST = new String[] { "IDACTUACION", "IDINSPECCION", "FECHAACTUACION",
			"IDTIPOACTUACION", "IDRESULTADOACTUACION", "PLAZO", "OBJETOVISITA", "OBSERVACIONESCASTELLANO",
			"OBSERVACIONESEUSKERA", "FECHAREGISTRO", "USUARIOREGISTRO", "FECHAULTMODIFICACION",
			"USUARIOULTMODIFICACION", "IDACTUACIONMOVIL", "SOPORTETABLET" };

	private JdbcTemplate jdbcTemplate;

	/*
	 * ROW_MAPPERS
	 */
	private RowMapper<Actuaciones> rwMap = new RowMapper<Actuaciones>() {
		@Override
		public Actuaciones mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			TiposActuacion tiposActuacion = new TiposActuacion();
			tiposActuacion.setIdTipoActuacion(resultSet.getLong("IDTIPOACTUACION"));
			tiposActuacion.setDescripcionCastellano(resultSet.getString("TIPODESCRIPCIONCASTELLANO"));
			tiposActuacion.setDescripcionEuskera(resultSet.getString("TIPODESCRIPCIONEUSKERA"));

			ResultadosActuacion resultadosActuacion = new ResultadosActuacion();
			resultadosActuacion.setIdResultadoActuacion(resultSet.getLong("IDRESULTADOACTUACION"));

			DesResAct desResAct = new DesResAct();
			desResAct.setIdDesResAct(resultSet.getInt("IDDESRESACT"));
			desResAct.setDescripcionCastellano(resultSet.getString("RESULDESCRIPCIONCASTELLANO"));
			desResAct.setDescripcionEuskera(resultSet.getString("RESULDESCRIPCIONEUSKERA"));
			resultadosActuacion.setDesResAct(desResAct);

			Inspecciones inspeccion = new Inspecciones();
			inspeccion.setIdInspeccion(resultSet.getInt("IDINSPECCION"));

			Actuaciones actuaciones = new Actuaciones();
			actuaciones.setIdActuacion(resultSet.getInt("IDACTUACION"));
			actuaciones.setIdActuacionMovil(resultSet.getString("IDACTUACIONMOVIL"));
			actuaciones.setInspeccion(inspeccion);
			actuaciones.setFechaActuacion(resultSet.getDate("FECHAACTUACION"));
			actuaciones.setTipoActuacion(tiposActuacion);
			actuaciones.setResultadoActuacion(resultadosActuacion);
			actuaciones.setPlazo(resultSet.getLong("PLAZO"));

			if (resultSet.wasNull()) {
				actuaciones.setPlazo(null);
			}

			actuaciones.setObjetoVisita(resultSet.getString("OBJETOVISITA"));
			actuaciones.setObservacionesCastellano(resultSet.getString("OBSERVACIONESCASTELLANO"));
			actuaciones.setObservacionesEuskera(resultSet.getString("OBSERVACIONESEUSKERA"));
			actuaciones.setFechaRegistro(resultSet.getDate("FECHAREGISTRO"));
			actuaciones.setUsuarioRegistro(resultSet.getString("USUARIOREGISTRO"));
			actuaciones.setFechaUltmodificacion(resultSet.getDate("FECHAULTMODIFICACION"));
			actuaciones.setUsuarioUltmodificacion(resultSet.getString("USUARIOULTMODIFICACION"));
			actuaciones.setSoporteTablet(resultSet.getInt("SOPORTETABLET"));

			return actuaciones;

		}
	};

	private RowMapper<Actuaciones> rwMapPK = new RowMapper<Actuaciones>() {
		@Override
		public Actuaciones mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			return new Actuaciones(resultSet.getInt("IDACTUACION"));
		}
	};

	private RowMapper<Actuaciones> rwMapPropuesta = new RowMapper<Actuaciones>() {
		@Override
		public Actuaciones mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			Inspecciones inspeccion = new Inspecciones();
			inspeccion.setIdInspeccion(resultSet.getInt("IDINSPECCION"));

			return new Actuaciones(resultSet.getInt("IDACTUACION"), resultSet.getString("IDACTUACIONMOVIL"), inspeccion,
					resultSet.getDate("FECHAACTUACION"), null, null, resultSet.getLong("PLAZO"),
					resultSet.getString("OBJETOVISITA"), resultSet.getString("OBSERVACIONESCASTELLANO"),
					resultSet.getString("OBSERVACIONESEUSKERA"), resultSet.getDate("FECHAREGISTRO"),
					resultSet.getString("USUARIOREGISTRO"), resultSet.getDate("FECHAULTMODIFICACION"),
					resultSet.getString("USUARIOULTMODIFICACION"), resultSet.getInt("SOPORTETABLET"));
		}
	};

	private RowMapper<Actuaciones> rwMapFind = new RowMapper<Actuaciones>() {
		@Override
		public Actuaciones mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			TiposActuacion tiposActuacion = new TiposActuacion();
			tiposActuacion.setIdTipoActuacion(resultSet.getLong("IDTIPOACTUACION"));
			tiposActuacion.setDescripcionCastellano(resultSet.getString("TIPODESCRIPCIONCASTELLANO"));
			tiposActuacion.setDescripcionEuskera(resultSet.getString("TIPODESCRIPCIONEUSKERA"));

			ResultadosActuacion resultadosActuacion = new ResultadosActuacion();
			resultadosActuacion.setIdResultadoActuacion(resultSet.getLong("IDRESULTADOACTUACION"));

			DesResAct desResAct = new DesResAct();
			desResAct.setIdDesResAct(resultSet.getInt("IDDESRESACT"));
			desResAct.setDescripcionCastellano(resultSet.getString("RESULDESCRIPCIONCASTELLANO"));
			desResAct.setDescripcionEuskera(resultSet.getString("RESULDESCRIPCIONEUSKERA"));
			resultadosActuacion.setDesResAct(desResAct);

			Actuaciones actuaciones = new Actuaciones();
			actuaciones.setIdActuacion(resultSet.getInt("IDACTUACION"));
			actuaciones.setIdActuacionMovil(resultSet.getString("IDACTUACIONMOVIL"));

			Inspecciones inspeccion = new Inspecciones();
			inspeccion.setIdInspeccion(resultSet.getInt("IDINSPECCION"));

			actuaciones.setInspeccion(inspeccion);
			actuaciones.setFechaActuacion(resultSet.getDate("FECHAACTUACION"));
			actuaciones.setTipoActuacion(tiposActuacion);
			actuaciones.setResultadoActuacion(resultadosActuacion);
			actuaciones.setPlazo(resultSet.getLong("PLAZO"));

			if (resultSet.wasNull()) {
				actuaciones.setPlazo(null);
			}

			actuaciones.setObjetoVisita(resultSet.getString("OBJETOVISITA"));
			actuaciones.setObservacionesCastellano(resultSet.getString("OBSERVACIONESCASTELLANO"));
			actuaciones.setObservacionesEuskera(resultSet.getString("OBSERVACIONESEUSKERA"));
			actuaciones.setFechaRegistro(resultSet.getDate("FECHAREGISTRO"));
			actuaciones.setUsuarioRegistro(resultSet.getString("USUARIOREGISTRO"));
			actuaciones.setFechaUltmodificacion(resultSet.getDate("FECHAULTMODIFICACION"));
			actuaciones.setUsuarioUltmodificacion(resultSet.getString("USUARIOULTMODIFICACION"));

			actuaciones.setCondicionCompareciente(resultSet.getString("CONDICIONCOMPARECIENTE"));
			actuaciones.setObservacionesCompareciente(resultSet.getString("OBSERVACIONESCOMPARECIENTE"));

			TiposDocumento tipoDocumento = new TiposDocumento();
			tipoDocumento.setIdTipoDocumento(resultSet.getLong("IDTIPODOCUMENTO"));

			DatosTerceros comparecienteAux = new DatosTerceros();
			comparecienteAux.setIdTercero(resultSet.getInt("IDTERCOMPARECIENTE"));
			comparecienteAux.setDocumento(resultSet.getString("DOCUMENTOCOMPARECIENTE"));
			comparecienteAux.setNombre(resultSet.getString("NOMBRE"));
			comparecienteAux.setApellido1(resultSet.getString("APELLIDO1"));
			comparecienteAux.setApellido2(resultSet.getString("APELLIDO2"));

			comparecienteAux.setTipoDocumento(tipoDocumento);

			comparecienteAux.setIdioma(resultSet.getObject("IDIOMA") == null ? null : resultSet.getInt("IDIOMA"));

			actuaciones.setCompareciente(comparecienteAux);

			Inspectores inspectorAux = new Inspectores();
			inspectorAux.setIdInspector(resultSet.getInt("IDINSPECTOR"));
			inspectorAux.setNombreInspector(resultSet.getString("NOMBREINSPECTOR"));
			actuaciones.setInspector(inspectorAux);
			actuaciones.setSoporteTablet(resultSet.getInt("SOPORTETABLET"));

			return actuaciones;

		}
	};

	private RowMapper<Actuacion> rwMapActuacionesREST = new RowMapper<Actuacion>() {
		@Override
		public Actuacion mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			Actuacion actuacion = new Actuacion();
			actuacion.setIdActuacion(resultSet.getInt("idactuacion"));
			actuacion.setIdActuacionMovil(resultSet.getString("idactuacionmovil"));
			actuacion.setIdInspector(resultSet.getInt("idinspector"));
			actuacion.setFechaActuacion(resultSet.getDate("fechaactuacion"));
			actuacion.setIdTipoActuacion(resultSet.getInt("idtipoactuacion"));
			actuacion.setIdResultadoActuacion(resultSet.getInt("idresultadoactuacion"));
			actuacion.setObjetoVisita(resultSet.getString("objetovisita"));
			actuacion.setObservacionesCastellano(resultSet.getString("observacionescastellano"));
			actuacion.setObservacionesEuskera(resultSet.getString("observacioneseuskera"));

			Compareciente compareciente = new Compareciente();
			compareciente.setDocumento(resultSet.getString("documento"));
			compareciente.setIdTipoDocumento(resultSet.getInt("idtipodocumento"));
			compareciente.setNombre(resultSet.getString("nombre"));
			compareciente.setApellido1(resultSet.getString("apellido1"));
			compareciente.setApellido2(resultSet.getString("apellido2"));

			compareciente.setIdioma(resultSet.getObject("IDIOMA") == null ? null : resultSet.getInt("IDIOMA"));

			compareciente.setCondicionCompareciente(resultSet.getString("condicioncompareciente"));
			compareciente.setObservacionesCompareciente(resultSet.getString("observacionescompareciente"));

			actuacion.setCompareciente(compareciente);

			return actuacion;

		}
	};

	/**
	 * Rowmapper para Jerarquía
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	private RowMapper<JerarquiaDto<Actuaciones>> rwMapJerarquia = new RowMapper<JerarquiaDto<Actuaciones>>() {
		@Override
		public JerarquiaDto<Actuaciones> mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			TiposActuacion tiposActuacion = new TiposActuacion();
			tiposActuacion.setIdTipoActuacion(resultSet.getLong("IDTIPOACTUACION"));
			tiposActuacion.setDescripcionCastellano(resultSet.getString("TIPODESCRIPCIONCASTELLANO"));
			tiposActuacion.setDescripcionEuskera(resultSet.getString("TIPODESCRIPCIONEUSKERA"));

			ResultadosActuacion resultadosActuacion = new ResultadosActuacion();
			resultadosActuacion.setIdResultadoActuacion(resultSet.getLong("IDRESULTADOACTUACION"));

			Inspecciones inspeccion = new Inspecciones();
			inspeccion.setIdInspeccion(resultSet.getInt("IDINSPECCION"));

			Actuaciones actuaciones = new Actuaciones(resultSet.getInt("IDACTUACION"),
					resultSet.getString("IDACTUACIONMOVIL"), inspeccion, resultSet.getDate("FECHAACTUACION"),
					tiposActuacion, resultadosActuacion, resultSet.getLong("PLAZO"),
					resultSet.getString("OBJETOVISITA"), resultSet.getString("OBSERVACIONESCASTELLANO"),
					resultSet.getString("OBSERVACIONESEUSKERA"), resultSet.getDate("FECHAREGISTRO"),
					resultSet.getString("USUARIOREGISTRO"), resultSet.getDate("FECHAULTMODIFICACION"),
					resultSet.getString("USUARIOULTMODIFICACION"), resultSet.getInt("SOPORTETABLET"));

			JerarquiaDto<Actuaciones> jerarquia = new JerarquiaDto<Actuaciones>();
			jerarquia.setModel(actuaciones);
			jerarquia.setLevel(resultSet.getBigDecimal("LEVEL").intValue());
			jerarquia.setParentNodes(resultSet.getString("PARENTNODES"));
			jerarquia.setIsLeaf(Boolean.parseBoolean(resultSet.getString("ISLEAF")));
			jerarquia.setFilter(Boolean.parseBoolean(resultSet.getString("FILTER")));
			return jerarquia;
		}
	};

	private RowMapper<Actuaciones> rwMapFechaMax = new RowMapper<Actuaciones>() {
		@Override
		public Actuaciones mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			Actuaciones actuaciones = new Actuaciones();
			actuaciones.setFechaActuacion(resultSet.getDate("FECHAACTUACION"));
			return actuaciones;
		}
	};

	/**
	 * Method use to set the datasource.
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	@Resource
	public void setDataSource(DataSource dataSource) {
		this.jdbcTemplate = new JdbcTemplate(dataSource);
	}

	/*
	 * OPERACIONES CRUD
	 */

	/**
	 * Inserts a single row in the Actuaciones table.
	 *
	 * @param actuaciones
	 *            Actuaciones
	 * @return Actuaciones
	 */
	@Override
	public Actuaciones add(Actuaciones actuaciones) {

		int idActuacion = this.jdbcTemplate.queryForObject("SELECT AB79.S_AB7914T00.NEXTVAL FROM DUAL",
				Integer.class);
		actuaciones.setIdActuacion(idActuacion);

		StringBuilder query = new StringBuilder();

		query.append("INSERT INTO ACTUACIONES (ID_ACTUACION, ID_INSPECCION, FECHA_ACTUACION, ID_TIPO_ACTUACION");
		query.append(", ID_RESULTADO_ACTUACION, PLAZO, OBJETO_VISITA");
		query.append(", OBSERVACIONES_CASTELLANO, OBSERVACIONES_EUSKERA");
		query.append(", ID_TER_COMPARECIENTE, CONDICION_COMPARECIENTE, OBSERVACIONES_COMPARECIENTE");
		query.append(", ID_INSPECTOR");
		query.append(
				", FECHA_REGISTRO, USUARIO_REGISTRO, ID_ACTUACION_MOVIL) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,sysdate,?,?)");

		Object getIdTerceroCompareciente = null;
		if (actuaciones.getCompareciente() != null && actuaciones.getCompareciente().getIdTercero() != null) {
			getIdTerceroCompareciente = actuaciones.getCompareciente().getIdTercero();
		}

		Object getIdInspector = null;
		if (actuaciones.getInspector() != null && actuaciones.getInspector().getIdInspector() != null) {
			getIdInspector = actuaciones.getInspector().getIdInspector();
		}

		this.jdbcTemplate.update(query.toString(), actuaciones.getIdActuacion(),
				actuaciones.getInspeccion() != null ? actuaciones.getInspeccion().getIdInspeccion() : null,
				actuaciones.getFechaActuacion(), actuaciones.getTipoActuacion().getIdTipoActuacion(),
				actuaciones.getResultadoActuacion().getIdResultadoActuacion(), actuaciones.getPlazo(),
				actuaciones.getObjetoVisita(), actuaciones.getObservacionesCastellano(),
				actuaciones.getObservacionesEuskera(), getIdTerceroCompareciente,
				actuaciones.getCondicionCompareciente(), actuaciones.getObservacionesCompareciente(), getIdInspector,
				actuaciones.getUsuarioRegistro(), actuaciones.getIdActuacionMovil());

		return actuaciones;
	}

	/**
	 * Updates a single row in the Actuaciones table.
	 *
	 * @param actuaciones
	 *            Actuaciones
	 * @return Actuaciones
	 */
	@Override
	public Actuaciones update(Actuaciones actuaciones) {

		StringBuilder query = new StringBuilder();

		query.append("UPDATE ACTUACIONES SET");
		query.append(" ID_INSPECCION=?, FECHA_ACTUACION=?, ID_TIPO_ACTUACION=?, ID_RESULTADO_ACTUACION=?");
		query.append(", PLAZO=?, OBJETO_VISITA=?, OBSERVACIONES_CASTELLANO=?, OBSERVACIONES_EUSKERA=?");
		query.append(", ID_TER_COMPARECIENTE = ?, CONDICION_COMPARECIENTE = ?, OBSERVACIONES_COMPARECIENTE = ?");
		query.append(", FECHA_ULTMODIFICACION=sysdate, USUARIO_ULTMODIFICACION=?");
		query.append(" WHERE ID_ACTUACION=?");

		Object getIdTerceroCompareciente = null;
		if (actuaciones.getCompareciente() != null && actuaciones.getCompareciente().getIdTercero() != null) {
			getIdTerceroCompareciente = actuaciones.getCompareciente().getIdTercero();
		}

		this.jdbcTemplate.update(query.toString(),
				actuaciones.getInspeccion() != null ? actuaciones.getInspeccion().getIdInspeccion() : null,
				actuaciones.getFechaActuacion(), actuaciones.getTipoActuacion().getIdTipoActuacion(),
				actuaciones.getResultadoActuacion().getIdResultadoActuacion(), actuaciones.getPlazo(),
				actuaciones.getObjetoVisita(), actuaciones.getObservacionesCastellano(),
				actuaciones.getObservacionesEuskera(), getIdTerceroCompareciente,
				actuaciones.getCondicionCompareciente(), actuaciones.getObservacionesCompareciente(),
				actuaciones.getUsuarioUltmodificacion(), actuaciones.getIdActuacion());
		return actuaciones;
	}

	/**
	 * Finds a single row in the Actuaciones table.
	 *
	 * @param actuaciones
	 *            Actuaciones
	 * @return Actuaciones
	 */
	@Override
	@Transactional(readOnly = true)
	public Actuaciones find(Actuaciones actuaciones) {

		StringBuilder query = new StringBuilder();

		query.append(
				"SELECT t1.ID_ACTUACION IDACTUACION, t1.ID_ACTUACION_MOVIL IDACTUACIONMOVIL, t1.ID_INSPECCION IDINSPECCION");
		query.append(", t1.FECHA_ACTUACION FECHAACTUACION, t1.ID_TIPO_ACTUACION IDTIPOACTUACION");
		query.append(", t1.ID_RESULTADO_ACTUACION IDRESULTADOACTUACION, t1.PLAZO PLAZO");
		query.append(", t1.OBJETO_VISITA OBJETOVISITA, t1.OBSERVACIONES_CASTELLANO OBSERVACIONESCASTELLANO");
		query.append(", t1.OBSERVACIONES_EUSKERA OBSERVACIONESEUSKERA, t1.FECHA_REGISTRO FECHAREGISTRO");
		query.append(", t1.USUARIO_REGISTRO USUARIOREGISTRO, t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION");
		query.append(", t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION");
		query.append(", t2.DESCRIPCION_CASTELLANO TIPODESCRIPCIONCASTELLANO");
		query.append(", t2.DESCRIPCION_EUSKERA TIPODESCRIPCIONEUSKERA, t4.ID_DES_RES_ACT IDDESRESACT");
		query.append(", t4.DESCRIPCION_CASTELLANO RESULDESCRIPCIONCASTELLANO");
		query.append(", t4.DESCRIPCION_EUSKERA RESULDESCRIPCIONEUSKERA");
		query.append(", t1.ID_TER_COMPARECIENTE IDTERCOMPARECIENTE, t1.CONDICION_COMPARECIENTE CONDICIONCOMPARECIENTE");
		query.append(", t1.OBSERVACIONES_COMPARECIENTE OBSERVACIONESCOMPARECIENTE");
		query.append(", t5.ID_TIPO_DOCUMENTO IDTIPODOCUMENTO, t5.DOCUMENTO DOCUMENTOCOMPARECIENTE");
		query.append(", t5.NOMBRE, t5.APELLIDO1, t5.APELLIDO2, t5.IDIOMA");
		query.append(
				", t1.ID_INSPECTOR IDINSPECTOR, t6.NOMBRE_INSPECTOR NOMBREINSPECTOR, t1.SOPORTE_TABLET SOPORTETABLET");

		query.append(
				" FROM ACTUACIONES t1, TIPOS_ACTUACION t2, RESULTADOS_ACTUACION t3, DES_RES_ACT t4, DATOS_TERCEROS t5, INSPECTORES t6");
		query.append(" WHERE t1.ID_ACTUACION = ? AND t1.ID_TIPO_ACTUACION=t2.ID_TIPO_ACTUACION");
		query.append(" AND t1.ID_RESULTADO_ACTUACION=t3.ID_RESULTADO_ACTUACION");
		query.append(" AND t3.ID_DES_RES_ACT = t4.ID_DES_RES_ACT ");
		query.append(" AND t1.ID_TER_COMPARECIENTE = t5.ID_TERCERO(+)");
		query.append(" AND t1.ID_INSPECTOR = t6.ID_INSPECTOR(+)");

		List<Actuaciones> actuacionesList = this.jdbcTemplate.query(query.toString(), this.rwMapFind,
				actuaciones.getIdActuacion());
		return DataAccessUtils.uniqueResult(actuacionesList);
	}

	@Override
	public List<Actuaciones> findByInspeccion(Inspecciones inspeccion) {
		String query = "SELECT t1.ID_ACTUACION IDACTUACION, t1.ID_ACTUACION_MOVIL IDACTUACIONMOVIL, t1.ID_INSPECCION IDINSPECCION, t1.FECHA_ACTUACION FECHAACTUACION, t1.ID_TIPO_ACTUACION IDTIPOACTUACION, t1.ID_RESULTADO_ACTUACION IDRESULTADOACTUACION, t1.PLAZO PLAZO, t1.OBJETO_VISITA OBJETOVISITA, t1.OBSERVACIONES_CASTELLANO OBSERVACIONESCASTELLANO, t1.OBSERVACIONES_EUSKERA OBSERVACIONESEUSKERA, t1.FECHA_REGISTRO FECHAREGISTRO, t1.USUARIO_REGISTRO USUARIOREGISTRO, t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION, t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION, t2.DESCRIPCION_CASTELLANO TIPODESCRIPCIONCASTELLANO, t2.DESCRIPCION_EUSKERA TIPODESCRIPCIONEUSKERA, t4.ID_DES_RES_ACT IDDESRESACT, t4.DESCRIPCION_CASTELLANO RESULDESCRIPCIONCASTELLANO, t4.DESCRIPCION_EUSKERA RESULDESCRIPCIONEUSKERA, t1.SOPORTE_TABLET SOPORTETABLET FROM ACTUACIONES t1, TIPOS_ACTUACION t2, RESULTADOS_ACTUACION t3, DES_RES_ACT t4 WHERE t1.ID_INSPECCION = ? AND t1.ID_TIPO_ACTUACION=t2.ID_TIPO_ACTUACION AND t1.ID_RESULTADO_ACTUACION=t3.ID_RESULTADO_ACTUACION AND t3.ID_DES_RES_ACT = t4.ID_DES_RES_ACT ";
		return this.jdbcTemplate.query(query, this.rwMap, inspeccion.getIdInspeccion());
	}

	@Override
	public int numeroDocumentosAsociados(Actuaciones actuacion) {
		String query = "SELECT COUNT(1) NUMERODOCUMENTOS FROM REL_ACT_DOC t1 WHERE t1.ID_ACTUACION = ?";
		List<Object> params = new ArrayList<Object>();
		params.add(actuacion.getIdActuacion());
		return this.jdbcTemplate.queryForObject(query, params.toArray(), Integer.class);
	}

	@Override
	public Integer findIdByIdActuacionMovil(String idActuacionMovil) {
		String query = "SELECT t14.ID_ACTUACION IDACTUACION FROM ACTUACIONES t14 WHERE t14.ID_ACTUACION_MOVIL = ?";
		List<Object> params = new ArrayList<Object>();
		params.add(idActuacionMovil);
		return this.jdbcTemplate.queryForObject(query, params.toArray(), Integer.class);
	}

	/**
	 * Removes a single row in the Actuaciones table.
	 *
	 * @param actuaciones
	 *            Actuaciones
	 * @return
	 */
	@Override
	public void remove(Actuaciones actuaciones) {

		String query = "DELETE FROM ACTUACIONES WHERE ID_ACTUACION=?";
		this.jdbcTemplate.update(query, actuaciones.getIdActuacion());

	}

	@Override
	public void removeByInspeccion(Inspecciones inspeccion) {
		String query = "DELETE FROM ACTUACIONES WHERE ID_INSPECCION = ?";
		this.jdbcTemplate.update(query, inspeccion.getIdInspeccion());
	}

	/**
	 * Exporta Datos al clipBoard
	 *
	 */
	@Override
	public List<Actuaciones> getMultiple(Actuaciones filterActuaciones, TableRequestDto tableRequestDto,
			Boolean startsWith) {

		// Where clause & Params
		Map<String, Object> mapaWhere = this.getWhereLikeMap(filterActuaciones, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));

		@SuppressWarnings("unchecked")
		List<Object> params = (List<Object>) mapaWhere.get("params");

		StringBuilder sbMultipleSQL = TableManager.getSelectMultipleQuery(tableRequestDto, Actuaciones.class, params,
				"IDACTUACION");

		return this.jdbcTemplate.query(sbMultipleSQL.toString(), this.rwMap, params.toArray());
	}

	/**
	 * Finds a list of rows in the Actuaciones table.
	 *
	 * @param actuaciones
	 *            Actuaciones
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<Actuaciones>
	 */
	@Override
	@Transactional(readOnly = true)
	public List<Actuaciones> findAll(Actuaciones actuaciones, TableRequestDto tableRequestDto) {

		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_ACTUACION IDACTUACION, t1.ID_ACTUACION_MOVIL IDACTUACIONMOVIL,"
						+ "t1.ID_INSPECCION IDINSPECCION," + "t1.FECHA_ACTUACION FECHAACTUACION,"
						+ "t1.ID_TIPO_ACTUACION IDTIPOACTUACION," + "t1.ID_RESULTADO_ACTUACION IDRESULTADOACTUACION,"
						+ "t1.PLAZO PLAZO,t1.OBJETO_VISITA OBJETOVISITA,"
						+ "t1.OBSERVACIONES_CASTELLANO OBSERVACIONESCASTELLANO,"
						+ "t1.OBSERVACIONES_EUSKERA OBSERVACIONESEUSKERA," + "t1.FECHA_REGISTRO FECHAREGISTRO,"
						+ "t1.USUARIO_REGISTRO USUARIOREGISTRO," + "t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,"
						+ "t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION, t1.SOPORTE_TABLET SOPORTETABLET ");

		query.append("FROM ACTUACIONES t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(actuaciones);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query, ActuacionesDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return this.jdbcTemplate.query(query.toString(), this.rwMapPropuesta, params.toArray());
	}

	/**
	 * Finds rows in the Actuaciones table using like.
	 *
	 * @param actuaciones
	 *            Actuaciones
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<Actuaciones>
	 */
	@Override
	@Transactional(readOnly = true)
	public List<Actuaciones> findAllLike(Actuaciones actuaciones, TableRequestDto tableRequestDto, Boolean startsWith) {
		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_ACTUACION IDACTUACION, t1.ID_ACTUACION_MOVIL IDACTUACIONMOVIL,t1.ID_INSPECCION IDINSPECCION,t1.FECHA_ACTUACION FECHAACTUACION,t1.ID_TIPO_ACTUACION IDTIPOACTUACION,t1.ID_RESULTADO_ACTUACION IDRESULTADOACTUACION,t1.PLAZO PLAZO,t1.OBJETO_VISITA OBJETOVISITA,t1.OBSERVACIONES_CASTELLANO OBSERVACIONESCASTELLANO,t1.OBSERVACIONES_EUSKERA OBSERVACIONESEUSKERA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION, t2.DESCRIPCION_CASTELLANO TIPODESCRIPCIONCASTELLANO, t2.DESCRIPCION_EUSKERA TIPODESCRIPCIONEUSKERA, t4.ID_DES_RES_ACT IDDESRESACT, t4.DESCRIPCION_CASTELLANO RESULDESCRIPCIONCASTELLANO, t4.DESCRIPCION_EUSKERA RESULDESCRIPCIONEUSKERA, t1.SOPORTE_TABLET SOPORTETABLET ");
		query.append("FROM ACTUACIONES t1, TIPOS_ACTUACION t2, RESULTADOS_ACTUACION t3, DES_RES_ACT t4 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(actuaciones, startsWith);
		StringBuilder where = new StringBuilder(
				" WHERE 1=1 AND t1.ID_TIPO_ACTUACION=t2.ID_TIPO_ACTUACION AND t1.ID_RESULTADO_ACTUACION=t3.ID_RESULTADO_ACTUACION AND t3.ID_DES_RES_ACT = t4.ID_DES_RES_ACT");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query);
		}

		return this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	@Override
	public List<Actuacion> findActuacionesREST(Integer idInspeccion) {
		String query = "SELECT t1.id_actuacion idactuacion, t1.ID_ACTUACION_MOVIL IDACTUACIONMOVIL, t1.id_inspector idinspector, t1.fecha_actuacion fechaactuacion, t1.id_tipo_actuacion idtipoactuacion, t1.id_resultado_actuacion idresultadoactuacion, t1.objeto_visita objetovisita, t1.observaciones_castellano observacionescastellano, t1.observaciones_euskera observacioneseuskera, t1.id_ter_compareciente idcompareciente, t2.documento documento, t2.id_tipo_documento idtipodocumento, t2.nombre nombre, t2.apellido1 apellido1, t2.apellido2 apellido2, t2.idioma idioma, t1.condicion_compareciente condicioncompareciente, t1.observaciones_compareciente observacionescompareciente FROM actuaciones t1, datos_terceros t2 WHERE t1.id_inspeccion = ? AND t1.id_ter_compareciente = t2.id_tercero";

		return this.jdbcTemplate.query(query, this.rwMapActuacionesREST, idInspeccion);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Counts rows in the Actuaciones table.
	 *
	 * @param actuaciones
	 *            Actuaciones
	 * @return Long
	 */
	@Override
	@Transactional(readOnly = true)
	public Long findAllCount(Actuaciones actuaciones) {
		StringBuilder query = new StringBuilder("SELECT COUNT(1) FROM ACTUACIONES t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(actuaciones);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Counts rows in the Actuaciones table using like.
	 *
	 * @param actuaciones
	 *            Actuaciones
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	@Override
	@Transactional(readOnly = true)
	public Long findAllLikeCount(Actuaciones actuaciones, Boolean startsWith) {
		StringBuilder query = new StringBuilder("SELECT COUNT(1) FROM ACTUACIONES t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(actuaciones, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Reorder the data list of Actuaciones selected for rup_table
	 *
	 * @param actuaciones
	 *            Actuaciones
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<Actuaciones>>
	 */
	@Override
	public List<TableRowDto<Actuaciones>> reorderSelection(Actuaciones actuaciones, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_ACTUACION IDACTUACION,t1.ID_INSPECCION IDINSPECCION,t1.FECHA_ACTUACION FECHAACTUACION,t1.ID_TIPO_ACTUACION IDTIPOACTUACION,t1.ID_RESULTADO_ACTUACION IDRESULTADOACTUACION,t1.PLAZO PLAZO,t1.OBJETO_VISITA OBJETOVISITA,t1.OBSERVACIONES_CASTELLANO OBSERVACIONESCASTELLANO,t1.OBSERVACIONES_EUSKERA OBSERVACIONESEUSKERA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION ");
		// FROM
		query.append("FROM ACTUACIONES t1 ");
		// FILTRADO
		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(actuaciones, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		// Parámetros de filtrado
		@SuppressWarnings("unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhere.get("params");

		// SQL para la reordenación
		StringBuilder sbReorderSelectionSQL = TableManager.getReorderQuery(query, tableRequestDto, Actuaciones.class,
				filterParamList, "IDACTUACION");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<Actuaciones>(this.rwMapPK, tableRequestDto), filterParamList.toArray());
	}

	/**
	 * Search method for rup_table
	 *
	 * @param filterParams
	 *            Actuaciones
	 * @param searchParams
	 *            Actuaciones
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<Actuaciones>>
	 */
	@Override
	public List<TableRowDto<Actuaciones>> search(Actuaciones filterParams, Actuaciones searchParams,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_ACTUACION IDACTUACION,t1.ID_INSPECCION IDINSPECCION,t1.FECHA_ACTUACION FECHAACTUACION,t1.ID_TIPO_ACTUACION IDTIPOACTUACION,t1.ID_RESULTADO_ACTUACION IDRESULTADOACTUACION,t1.PLAZO PLAZO,t1.OBJETO_VISITA OBJETOVISITA,t1.OBSERVACIONES_CASTELLANO OBSERVACIONESCASTELLANO,t1.OBSERVACIONES_EUSKERA OBSERVACIONESEUSKERA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION ");
		// FROM
		query.append("FROM ACTUACIONES t1 ");
		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// FILTRADO
		Map<String, ?> mapaWhereFilter = this.getWhereLikeMap(filterParams, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhereFilter.get("query"));
		query.append(where);
		// Filter params
		@SuppressWarnings("unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhereFilter.get("params");

		// BUSQUEDA
		Map<String, Object> mapaWhereSearch = this.getWhereLikeMap(searchParams, startsWith);
		String searchSQL = ((StringBuilder) mapaWhereSearch.get("query")).toString();
		// Search params
		@SuppressWarnings("unchecked")
		List<Object> searchParamList = (List<Object>) mapaWhereSearch.get("params");

		// SQL
		StringBuilder sbReorderSelectionSQL = TableManager.getSearchQuery(query, tableRequestDto, Actuaciones.class,
				filterParamList, searchSQL, searchParamList, from_alias, "IDACTUACION");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<Actuaciones>(this.rwMapPK, tableRequestDto), filterParamList.toArray());
	}

	/**
	 * Remove multiple method for rup_table
	 *
	 * @param filteractuaciones
	 *            Actuaciones
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	@Override
	public void removeMultiple(Actuaciones filteractuaciones, TableRequestDto tableRequestDto, Boolean startsWith) {
		// SELECT
		/** TODO: select por clave */
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_ACTUACION IDACTUACION,t1.ID_INSPECCION IDINSPECCION,t1.FECHA_ACTUACION FECHAACTUACION,t1.ID_TIPO_ACTUACION IDTIPOACTUACION,t1.ID_RESULTADO_ACTUACION IDRESULTADOACTUACION,t1.PLAZO PLAZO,t1.OBJETO_VISITA OBJETOVISITA,t1.OBSERVACIONES_CASTELLANO OBSERVACIONESCASTELLANO,t1.OBSERVACIONES_EUSKERA OBSERVACIONESEUSKERA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION ");
		// FROM
		query.append("FROM ACTUACIONES t1 ");

		// WHERE
		Map<String, Object> mapaWhere = this.getWhereLikeMap(filteractuaciones, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		@SuppressWarnings("unchecked")
		List<Object> params = (List<Object>) mapaWhere.get("params");

		StringBuilder sbRemoveMultipleSQL = TableManager.getRemoveMultipleQuery(tableRequestDto, Actuaciones.class,
				query, params, "IDACTUACION");
		this.jdbcTemplate.update(sbRemoveMultipleSQL.toString(), params.toArray());
	}

	/**
	 * Filter in the hierarchical Actuaciones table.
	 *
	 * @param filterActuaciones
	 *            Actuaciones
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<JerarquiaDto<Actuaciones>>
	 */
	@Override
	public List<JerarquiaDto<Actuaciones>> findAllLikeJerarquia(Actuaciones filterActuaciones,
			TableRequestDto tableRequestDto) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_ACTUACION IDACTUACION,t1.ID_ACTUACION_MOVIL IDACTUACIONMOVIL,t1.ID_INSPECCION IDINSPECCION,t1.FECHA_ACTUACION FECHAACTUACION,t1.ID_TIPO_ACTUACION IDTIPOACTUACION,t1.ID_RESULTADO_ACTUACION IDRESULTADOACTUACION,t1.PLAZO PLAZO,t1.OBJETO_VISITA OBJETOVISITA,t1.OBSERVACIONES_CASTELLANO OBSERVACIONESCASTELLANO,t1.OBSERVACIONES_EUSKERA OBSERVACIONESEUSKERA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION, t1.SOPORTE_TABLET SOPORTETABLET ");
		// FROM
		// StringBuilder from = new StringBuilder("FROM ACTUACIONES t1 ");
		List<String> from = new ArrayList<String>();
		from.add("ACTUACIONES");
		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterActuaciones, false);

		// JERARQUIA
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		query = TableManagerJerarquia.getQuery(tableRequestDto, query, mapaWhere, "IDACTUACION", "ID_PADRE", "NOMBRE",
				from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// query = TableManagerJerarquia.getQuery(tableRequestDto, query,
		// mapaWhere, "ID", "ID_PADRE", "NOMBRE", from, from_alias, joins,
		// businessFilters, businessParams);

		// PAGINACION
		if (tableRequestDto != null) {
			query = TableManagerJerarquia.getPaginationQuery(tableRequestDto, query,
					ActuacionesDaoImpl.ORDER_BY_WHITE_LIST);
		}

		List<?> params = (List<?>) mapaWhere.get("params");
		return this.jdbcTemplate.query(query.toString(), this.rwMapJerarquia, params.toArray());
	}

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterActuaciones
	 *            Actuaciones
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return Long
	 */
	@Override
	public Long findAllLikeCountJerarquia(Actuaciones filterActuaciones, TableRequestDto tableRequestDto) {
		// FROM
		// StringBuilder from = new StringBuilder("FROM ACTUACIONES t1 ");
		List<String> from = new ArrayList<String>();
		from.add("ACTUACIONES");

		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterActuaciones, false);

		// JERARQUIA
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		StringBuilder query = TableManagerJerarquia.getQueryCount(tableRequestDto, mapaWhere, "IDACTUACION", "ID_PADRE",
				from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// StringBuilder query =
		// TableManagerJerarquia.getQueryCount(tableRequestDto, mapaWhere, "ID",
		// "ID_PADRE", from, from_alias, joins, businessFilters,
		// businessParams);

		List<?> params = (List<?>) mapaWhere.get("params");
		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterActuaciones
	 *            Actuaciones
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<TableRowDto<Actuaciones>>
	 */
	@Override
	public List<TableRowDto<Actuaciones>> findAllChild(Actuaciones filterActuaciones, TableRequestDto tableRequestDto) {

		// FROM
		// StringBuilder from = new StringBuilder("FROM ACTUACIONES t1 ");
		List<String> from = new ArrayList<String>();
		from.add("ACTUACIONES");

		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterActuaciones, false);

		// MULTISELECCION
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		StringBuilder query = TableManagerJerarquia.getQueryChildren(tableRequestDto, mapaWhere, "IDACTUACION",
				"ID_PADRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// StringBuilder query =
		// TableManagerJerarquia.getQueryChildren(tableRequestDto, mapaWhere,
		// "ID", "ID_PADRE", from, from_alias, joins, businessFilters,
		// businessParams);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.query(query.toString(),
				new RowNumResultSetExtractor<Actuaciones>(this.rwMapPK, "IDACTUACION"), params.toArray());
	}

	/*
	 * MÉTODOS PRIVADOS
	 */

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the Actuaciones entity
	 *
	 * @param actuaciones
	 *            Actuaciones Bean with the criteria values to filter by.
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, ?> getWhereMap(Actuaciones actuaciones) {

		StringBuilder where = new StringBuilder(ActuacionesDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (actuaciones != null && actuaciones.getIdActuacion() != null) {
			where.append(" AND t1.ID_ACTUACION = ?");
			params.add(actuaciones.getIdActuacion());
		}
		if (actuaciones != null && actuaciones.getInspeccion() != null
				&& actuaciones.getInspeccion().getIdInspeccion() != null) {
			where.append(" AND t1.ID_INSPECCION = ?");
			params.add(actuaciones.getInspeccion().getIdInspeccion());
		}
		if (actuaciones != null && actuaciones.getFechaActuacion() != null) {
			where.append(" AND t1.FECHA_ACTUACION = ?");
			params.add(actuaciones.getFechaActuacion());
		}
		if (actuaciones != null && actuaciones.getTipoActuacion() != null
				&& actuaciones.getTipoActuacion().getIdTipoActuacion() != null) {
			where.append(" AND t1.ID_TIPO_ACTUACION = ?");
			params.add(actuaciones.getTipoActuacion().getIdTipoActuacion());
		}
		if (actuaciones != null && actuaciones.getResultadoActuacion() != null
				&& actuaciones.getResultadoActuacion().getIdResultadoActuacion() != null) {
			where.append(" AND t1.ID_RESULTADO_ACTUACION = ?");
			params.add(actuaciones.getResultadoActuacion().getIdResultadoActuacion());
		}
		if (actuaciones != null && actuaciones.getPlazo() != null) {
			where.append(" AND t1.PLAZO = ?");
			params.add(actuaciones.getPlazo());
		}
		if (actuaciones != null && actuaciones.getObjetoVisita() != null) {
			where.append(" AND t1.OBJETO_VISITA = ?");
			params.add(actuaciones.getObjetoVisita());
		}
		if (actuaciones != null && actuaciones.getObservacionesCastellano() != null) {
			where.append(" AND t1.OBSERVACIONES_CASTELLANO = ?");
			params.add(actuaciones.getObservacionesCastellano());
		}
		if (actuaciones != null && actuaciones.getObservacionesEuskera() != null) {
			where.append(" AND t1.OBSERVACIONES_EUSKERA = ?");
			params.add(actuaciones.getObservacionesEuskera());
		}
		if (actuaciones != null && actuaciones.getFechaRegistro() != null) {
			where.append(" AND t1.FECHA_REGISTRO = ?");
			params.add(actuaciones.getFechaRegistro());
		}
		if (actuaciones != null && actuaciones.getUsuarioRegistro() != null) {
			where.append(" AND t1.USUARIO_REGISTRO = ?");
			params.add(actuaciones.getUsuarioRegistro());
		}
		if (actuaciones != null && actuaciones.getFechaUltmodificacion() != null) {
			where.append(" AND t1.FECHA_ULTMODIFICACION = ?");
			params.add(actuaciones.getFechaUltmodificacion());
		}
		if (actuaciones != null && actuaciones.getUsuarioUltmodificacion() != null) {
			where.append(" AND t1.USUARIO_ULTMODIFICACION = ?");
			params.add(actuaciones.getUsuarioUltmodificacion());
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the Actuaciones entity
	 *
	 * @param actuaciones
	 *            Actuaciones Bean with the criteria values to filter by.
	 * @param startsWith
	 *            Boolean
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, Object> getWhereLikeMap(Actuaciones actuaciones, Boolean startsWith) {

		StringBuilder where = new StringBuilder(ActuacionesDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (actuaciones != null && actuaciones.getIdActuacion() != null) {
			where.append(" AND t1.ID_ACTUACION = ?");
			params.add(actuaciones.getIdActuacion());
		}
		if (actuaciones != null && actuaciones.getInspeccion() != null
				&& actuaciones.getInspeccion().getIdInspeccion() != null) {
			where.append(" AND t1.ID_INSPECCION = ?");
			params.add(actuaciones.getInspeccion().getIdInspeccion());
		}
		if (actuaciones != null && actuaciones.getFechaActuacion() != null) {
			where.append(" AND t1.FECHA_ACTUACION = ?");
			params.add(actuaciones.getFechaActuacion());
		}
		if (actuaciones != null && actuaciones.getTipoActuacion() != null
				&& actuaciones.getTipoActuacion().getIdTipoActuacion() != null) {
			where.append(" AND t1.ID_TIPO_ACTUACION = ?");
			params.add(actuaciones.getTipoActuacion().getIdTipoActuacion());
		}
		if (actuaciones != null && actuaciones.getResultadoActuacion() != null
				&& actuaciones.getResultadoActuacion().getIdResultadoActuacion() != null) {
			where.append(" AND t1.ID_RESULTADO_ACTUACION = ?");
			params.add(actuaciones.getResultadoActuacion().getIdResultadoActuacion());
		}
		if (actuaciones != null && actuaciones.getPlazo() != null) {
			where.append(" AND t1.PLAZO = ?");
			params.add(actuaciones.getPlazo());
		}
		if (actuaciones != null && actuaciones.getObjetoVisita() != null) {
			where.append(" AND UPPER(t1.OBJETO_VISITA) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(actuaciones.getObjetoVisita().toUpperCase() + "%");
			} else {
				params.add("%" + actuaciones.getObjetoVisita().toUpperCase() + "%");
			}
			where.append(" AND t1.OBJETO_VISITA IS NOT NULL");
		}
		if (actuaciones != null && actuaciones.getObservacionesCastellano() != null) {
			where.append(" AND UPPER(t1.OBSERVACIONES_CASTELLANO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(actuaciones.getObservacionesCastellano().toUpperCase() + "%");
			} else {
				params.add("%" + actuaciones.getObservacionesCastellano().toUpperCase() + "%");
			}
			where.append(" AND t1.OBSERVACIONES_CASTELLANO IS NOT NULL");
		}
		if (actuaciones != null && actuaciones.getObservacionesEuskera() != null) {
			where.append(" AND UPPER(t1.OBSERVACIONES_EUSKERA) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(actuaciones.getObservacionesEuskera().toUpperCase() + "%");
			} else {
				params.add("%" + actuaciones.getObservacionesEuskera().toUpperCase() + "%");
			}
			where.append(" AND t1.OBSERVACIONES_EUSKERA IS NOT NULL");
		}
		if (actuaciones != null && actuaciones.getFechaRegistro() != null) {
			where.append(" AND t1.FECHA_REGISTRO = ?");
			params.add(actuaciones.getFechaRegistro());
		}
		if (actuaciones != null && actuaciones.getUsuarioRegistro() != null) {
			where.append(" AND UPPER(t1.USUARIO_REGISTRO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(actuaciones.getUsuarioRegistro().toUpperCase() + "%");
			} else {
				params.add("%" + actuaciones.getUsuarioRegistro().toUpperCase() + "%");
			}
			where.append(" AND t1.USUARIO_REGISTRO IS NOT NULL");
		}
		if (actuaciones != null && actuaciones.getFechaUltmodificacion() != null) {
			where.append(" AND t1.FECHA_ULTMODIFICACION = ?");
			params.add(actuaciones.getFechaUltmodificacion());
		}
		if (actuaciones != null && actuaciones.getUsuarioUltmodificacion() != null) {
			where.append(" AND UPPER(t1.USUARIO_ULTMODIFICACION) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(actuaciones.getUsuarioUltmodificacion().toUpperCase() + "%");
			} else {
				params.add("%" + actuaciones.getUsuarioUltmodificacion().toUpperCase() + "%");
			}
			where.append(" AND t1.USUARIO_ULTMODIFICACION IS NOT NULL");
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/*
	 * Obtenemos la fecha maxima de las actuaciones
	 */
	@Override
	public Actuaciones findMaxDateActuaciones(Integer idInspeccion) {

		StringBuilder query = new StringBuilder(
				"SELECT MAX(FECHA_ACTUACION) FECHAACTUACION FROM ACTUACIONES WHERE ID_INSPECCION = ? ");

		List<Actuaciones> actuacionesList = this.jdbcTemplate.query(query.toString(), this.rwMapFechaMax, idInspeccion);
		return DataAccessUtils.uniqueResult(actuacionesList);

	}

	/**
	 * StringBuilder initilization value
	 */
	public static final int STRING_BUILDER_INIT = 4096;

}
